/**********************************************************************/
/* DIALOGUE.C : Construction des boites de dialogue pour l'editeur JE */
/**********************************************************************/

/*
    Copyright (C) 1996, 1997 Free Software Foundation, Inc.
    Ce programme fait partie du package JE et est soumis, comme le
    reste du package JE, a la Gnu General Public License version 2
    ou superieure dont voici un extrait et dont vous pouvez lire
    la totalite en consultant le fichier COPYING.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>
#include "je.h"
#include "formulr.h"

static FORMLISTE fliste;	/* liste des formulaires de ce programme */

PTFORMU fcherche;	 /* formulaire 1 */
static PTFZONE zfcherche[4];	/* zones du formulaire fcherche (1) */
static PTFTEXT tfcherche[4];	/* textes du formulaire fcherche (1) */

char vachercher[42];		 /* pour la zone 1 de fcherche (1) */
char vremplacer[42];		 /* pour la zone 2 de fcherche (1) */
char vignorer[2];		 /* pour la zone 3 de fcherche (1) */

PTFORMU fcmdline;
static PTFZONE zfcmdline[2];

char vcmdline[66];	/* ligne de commande */

PTFORMU formmacro;
static PTFZONE zformmacro[2];

char vmacroname[66];	/* nom de la macro */

/**********************************************************************/
void delete_forms(void)
{
	free_allocated_fliste(&fliste);
}
/**********************************************************************/
int create_forms(void)
{
	int i;		/* compteur */
	chtype cf;
	chtype cn;

	/* indique que la liste est vide */
	fliste.ffirst = NULL;

	/* Creation du formulaire fcherche (1) */
	fcherche = cree_formulaire_vide(&fliste);
	if (fcherche == NULL)
		return(-1);
	if (language == ENGLISH)
		fcherche->ftitre = " Find & Replace ";
	else
		fcherche->ftitre = " Chercher & Remplacer ";

	/* Creation des textes du formulaire fcherche (1) */
	for (i = 0; i < 3; i++)
	{
		tfcherche[i] = cree_texte_vide(fcherche);
		if (tfcherche[i] == NULL)
			return(-1);
	}

	/* Initialisation des textes du formulaire fcherche (1) */
	tfcherche[0]->xr = 2;
	tfcherche[0]->yr = 2;
	if (language == ENGLISH)
		tfcherche[0]->texte = "          Find: ";
	else
		tfcherche[0]->texte = "      Chercher: ";

	tfcherche[1]->xr = 2;
	tfcherche[1]->yr = 4;
	if (language == ENGLISH)
		tfcherche[1]->texte = "  Replace with: ";
	else
		tfcherche[1]->texte = " Remplacer par: ";

	tfcherche[2]->xr = 2;
	tfcherche[2]->yr = 6;
	if (language == ENGLISH)
		tfcherche[2]->texte = "   Ignore case: ";
	else
		tfcherche[2]->texte = "    Ignore MAJ: ";

	/* Creation des zones du formulaire fcherche (1) */
	for (i = 0; i < 3; i++)
	{
		zfcherche[i] = cree_zone_vide(fcherche);
		if (zfcherche[i] == NULL)
			return(-1);
	}

	/* Initialisation des zones du formulaire fcherche (1) */
	zfcherche[0]->xr = 18;
	zfcherche[0]->yr = 2;
	zfcherche[0]->force = FORCESAISIE;
	zfcherche[0]->variable = vachercher;
	zfcherche[0]->format = "ssssssssssssssssssssssssssssssssssssssss";
	zfcherche[0]->fill   = "                                        ";
	if (language == ENGLISH)
		zfcherche[0]->aidenlig = "Type the string to be Found / Replaced";
	else
		zfcherche[0]->aidenlig = "Tapez la chaine a chercher / Remplacer";

	zfcherche[1]->xr = 18;
	zfcherche[1]->yr = 4;
	zfcherche[1]->variable = vremplacer;
	zfcherche[1]->format = "ssssssssssssssssssssssssssssssssssssssss";
	zfcherche[1]->fill   = "                                        ";
	if (language == ENGLISH)
		zfcherche[1]->aidenlig = "Type the string to Replace with";
	else
		zfcherche[1]->aidenlig = "Tapez la chaine de remplacement";

	zfcherche[2]->xr = 18;
	zfcherche[2]->yr = 6;
	zfcherche[2]->force = FORCESAISIE;
	zfcherche[2]->variable = vignorer;
	zfcherche[2]->format = "Y";
	zfcherche[2]->fill   = " ";
	if (language == ENGLISH)
		zfcherche[2]->aidenlig = "Do you want to ignore case ?";
	else
		zfcherche[2]->aidenlig = "Voulez-vous ignorer les differences entre MAJUSCULES et minuscules ?";

	fcmdline = cree_formulaire_vide(&fliste);
	if (fcmdline == NULL)
		return(-1);
	if (language == ENGLISH)
		fcmdline->ftitre = "Run a command";
	else
		fcmdline->ftitre = "Executer une commande";

	for (i = 0; i < 1; i++)
	{
		zfcmdline[i] = cree_zone_vide(fcmdline);
		if (zfcmdline[i] == NULL)
			return(-1);
	}

	zfcmdline[0]->xr = 2;
	zfcmdline[0]->yr = 1;
	zfcmdline[0]->variable = vcmdline;
	zfcmdline[0]->format = "ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss";
	zfcmdline[0]->fill   = "                                                                ";
	if (language == ENGLISH)
		zfcmdline[0]->aidenlig = "Type the command to be executed";
	else
		zfcmdline[0]->aidenlig = "Tapez la commande a executer";

	formmacro = cree_formulaire_vide(&fliste);
	if (formmacro == NULL)
		return(-1);
	if (language == ENGLISH)
		formmacro->ftitre = "Save a macro";
	else
		formmacro->ftitre = "Sauver une macro";

	for (i = 0; i < 1; i++)
	{
		zformmacro[i] = cree_zone_vide(formmacro);
		if (zformmacro[i] == NULL)
			return(-1);
	}

	zformmacro[0]->xr = 2;
	zformmacro[0]->yr = 1;
	zformmacro[0]->variable = vmacroname;
	zformmacro[0]->format = "ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss";
	zformmacro[0]->fill   = "                                                                ";
	if (language == ENGLISH)
		zformmacro[0]->aidenlig = "Type a name for this macro";
	else
		zformmacro[0]->aidenlig = "Tapez un nom pour cette macro";

	cf = couleur[COULEUR_ALERTE1];
	cn = couleur[COULEUR_NORMALE];
	init_application_fliste(&fliste, NULL, SIMPLECADRE, MODEROULEAU, cf, cf, cf, cf, cn, cn, couleur[COULEUR_ALERTE2]);

	return(0);
}
/**********************************************************************/
