/**********************************************************************/
/* MISC.C : Fonctions sans lien particulier avec le reste de JE	      */
/**********************************************************************/

/*
    Copyright (C) 1996, 1997 Free Software Foundation, Inc.
    Ce programme fait partie du package JE et est soumis, comme le
    reste du package JE, a la Gnu General Public License version 2
    ou superieure dont voici un extrait et dont vous pouvez lire
    la totalite en consultant le fichier COPYING.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <ctype.h>
#include "je.h"

extern int insert_mode;
/**********************************************************************/
void erreur(char *fmt, char *mess)
{
	char tmp[80];

	if (mess != NULL)
		sprintf(tmp, fmt, mess);
	else
		strcpy(tmp, fmt);
	alerte(1, tmp, "OK");
}
/**********************************************************************/
int cfamily(char *filename)
{
	char *ptl;

	/* on cherche l'extension eventuelle en partant de la fin */
	ptl = filename + strlen(filename);
	while ((ptl > filename) && (*ptl != '.'))
		ptl--;

	/* extension trouvee */
	if (*ptl == '.')
	{
		if ((! strcmp(ptl, ".c")) || (! strcmp(ptl, ".C"))
		 || (! strcmp(ptl, ".cc")) || (! strcmp(ptl, ".CC"))
		 || (! strcmp(ptl, ".cpp")) || (! strcmp(ptl, ".CPP"))
		 || (! strcmp(ptl, ".h")) || (! strcmp(ptl, ".H")))
			{
				return(1);	/* fichier source de type C */
			}
	}
	return(0);	/* autre type de fichier */
}
/**********************************************************************/
int question(void)
{
	chtype buffer[256];
	char *mess;
	int touche;


	if (language == ENGLISH)
		mess = "Continue/Replace/All/Stop ? (C/R/A/S)";
	else
		mess = "Continue/Remplace/Tout/Stop ? (C/R/T/S)";

	get_txt(0, (LINES - 1), (COLS - 1), (LINES - 1), buffer);
	put_statligne(0, (LINES - 1), mess, couleur[COULEUR_AIDE]);
	refresh();
	do
	{
		touche = fread_key();
		touche = toupper(touche);
		if ((language == FRENCH) && (touche == 'T'))
			touche = 'A';
	}
	while ((touche != 'C') && (touche != 'R') && (touche != 'A') && (touche != 'S')) ;
	put_txt(0, (LINES - 1), (COLS - 1), (LINES - 1), buffer);
	return(touche);
}
/**********************************************************************/
chtype *sauve_ecran(void)
{
	chtype *buffer;

	buffer = (chtype *)malloc(LINES * COLS * sizeof(chtype));
	if (buffer != NULL)
	{
		get_txt(0, 0, (COLS - 1), (LINES - 1), buffer);

		clr_scr();

		def_prog_mode();
		reset_shell_mode();
	}
	return(buffer);
}
/**********************************************************************/
void restaure_ecran(chtype *buffer, int waitakey)
{
	reset_prog_mode();

	if (waitakey == ATTENDSTOUCHE)
	{
		if (language == ENGLISH)
			put_statligne(0, (LINES - 1), "Press any key...", couleur[COULEUR_AIDE]);
		else
			put_statligne(0, (LINES - 1), "Pressez une touche...", couleur[COULEUR_AIDE]);
		fread_key();
	}

	clr_scr();

	put_txt(0, 0, (COLS - 1), (LINES - 1), buffer);

	refresh();

	free(buffer);
}
/**********************************************************************/
void affiche_status_line(FICHIER *fichier, int colonne)
{
	char *chinsertion;	/* pour libelle Insertion/Remplacement */
	char status_line[256];	/* pour ligne d'etat */
	char mac;		/* pour etat de la macro */
	int lgl;		/* longueur de la ligne */
	int lgf;		/* longueur du nom de fichier */


	if (language == ENGLISH)
		chinsertion = ((insert_mode == INSERT) ? "INSERT " : "REPLACE");
	else
		chinsertion = ((insert_mode == INSERT) ? "INSERE  " : "REMPLACE");
	if (macro == RECORDING)
		mac = 'R';
	else if (macro == PLAYING)
		mac = 'P';
	else
		mac = ' ';
	if (language == ENGLISH)
		sprintf(status_line, "Col:%3i  Line:%5i/%5i  %c  %s  ", colonne, fichier->numcourante, fichier->nblignes, mac, chinsertion);
	else
		sprintf(status_line, "Col:%3i  Ligne:%5i/%5i  %c  %s  ", colonne, fichier->numcourante, fichier->nblignes, mac, chinsertion);

	/* coupe eventuellement le nom de fichier */
	/* pour n'afficher que la fin de celui-ci */
	lgl = strlen(status_line);
	lgf = strlen(fichier->filename);
	if ((lgl + lgf) >= (COLS - 5))	 /* pour le 5 voir ci-dessous */
	{
		strcat(status_line, "(...)");	/* 5 caracteres en plus */
		strcat(status_line, fichier->filename + (lgl + lgf + 5 - COLS));
	}
	else
		strcat(status_line, fichier->filename);

	put_statligne(0, 0, status_line, couleur[COULEUR_STATUS]);
}
/**********************************************************************/
void affiche_help_line(void)
{
	if (language == ENGLISH)
		put_statligne(0, (LINES - 1), "1/Cmd 2/Sh 3/Quit 4/Save 5/Find&Replace 6/Mark 7/Unmark 8/Copy 9/Move 10/Remove", couleur[COULEUR_AIDE]);
	else
		put_statligne(0, (LINES - 1), "1/Cmd 2/Sh 3/Quitte 4/Sauve 5/C&R 6/Marque 7/Demarque 8/Copie 9/Deplace 10/Suppr", couleur[COULEUR_AIDE]);
}
/**********************************************************************/
void inverse_insert_mode(void)
{
	if (insert_mode == INSERT)
	{
		insert_mode = REPLACE;
		allume_curseur(2);	/* gros curseur */
	}
	else
	{
		insert_mode = INSERT;
		allume_curseur(1);	/* petit curseur */
	}
}
/**********************************************************************/
int confirmation(char *question)
{
	char *yesno;

	if (language == FRENCH)
		yesno = "OUI|NON";
	else
		yesno = "YES|NO";

	if (alerte(1, question, yesno) == 1)
		return(1);
	else
		return(0);
}
/**********************************************************************/
